local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

local buff = x.Buff
local cooldown = x.Cooldown
local talent = x.Talent
local target = x.Target

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()

	s.UpdateTarget()
	s.UpdateBloodlust()
	x.InCombat = s.InCombat()
	x.GCD = s.GlobalCooldown()
	x.Spec = s.TalentMastery()
	x.MaxHealth = s.MaxHealth("player")
	x.Health = s.Health("player")
	x.HealthPercent = s.HealthPercent("player")
	x.ActiveEnemies = s.SpellTargets()
	x.MaxGCD = math.max(1, 150 / (100 + UnitSpellHaste("player")))
	x.UseLongCD = s.UseLongCD()
	
	if x.Spec == 1 then
		-- Holy
		x.Mana = s.Power("player",  Enum.PowerType.Mana )
		x.MaxMana = s.MaxPower("player",  Enum.PowerType.Mana )

		-- Executed before combat begins. Accepts non-harmful actions only.
		if not x.InCombat and x.EnemyDetected then
			a.Flash(
				"flask"
				,"food"
				,"augmentation"
				,"potion"
			)
		end

		a.Flash("rebuke")

	elseif x.Spec == 2 then
		-- Protection
		-- https://github.com/simulationcraft/simc/commit/55272492c35e597cabcdd359910e4d3936a15525

		-- Executed before combat begins. Accepts non-harmful actions only.
		if not x.InCombat and x.Enemy then
			a.Flash(
				"flask"
				,"food"
				,"augmentation"
				,"potion"
				,"avenging_wrath"
				,"seraphim"
			)
			return
		end

		a.Flash("rebuke")
		a.Flash("hand_of_reckoning")

		s.UpdateCooldown(53600, "Shield of the Righteous")
		s.UpdateCooldown(275779, "Judgment")
		s.UpdateCooldown(152262, "Seraphim")
		s.UpdateBuff(197561, "Avenger's Valor")
		s.UpdateBuff(152262, "Seraphim")
		s.UpdateBuff(31884, "Avenging Wrath")

		-- Cooldowns
		a.Flash(
				"lay_on_hands,if=health.pct<15"
--				,"fireblood,if=buff.avenging_wrath.up"
				,"seraphim,if=cooldown.shield_of_the_righteous.charges_fractional>=2"
				,"avenging_wrath,if=buff.seraphim.up|cooldown.seraphim.remains<2|!talent.seraphim.enabled"
				,"bastion_of_light,if=cooldown.shield_of_the_righteous.charges_fractional<=0.5"
--				,"potion,if=buff.avenging_wrath.up"
		)

		-- Dumping SotR charges
		a.Flash(
				"shield_of_the_righteous,if=(buff.avengers_valor.up&cooldown.shield_of_the_righteous.charges_fractional>=2.5)&(cooldown.seraphim.remains>gcd|!talent.seraphim.enabled)"
				,"shield_of_the_righteous,if=(buff.avenging_wrath.up&!talent.seraphim.enabled)|buff.seraphim.up&buff.avengers_valor.up"
				,"shield_of_the_righteous,if=(buff.avenging_wrath.up&buff.avenging_wrath.remains<4&!talent.seraphim.enabled)|(buff.seraphim.remains<4&buff.seraphim.up)"
				,"light_of_the_protector,if=health.pct<40"
				,"hand_of_the_protector,if=health.pct<40"
				,"light_of_the_protector,if=(incoming_damage_6000ms<health.max*0.7)&health.pct<65&talent.righteous_protector.enabled"
				,"light_of_the_protector,if=(incoming_damage_9000ms<health.max*1.2)&health.pct<55"
				,"hand_of_the_protector,if=(incoming_damage_6000ms<health.max*0.7)&health.pct<65&talent.righteous_protector.enabled"
				,"hand_of_the_protector,if=(incoming_damage_9000ms<health.max*1.2)&health.pct<55"
				,"consecration,if=!consecration.up"
				,"judgment,if=(cooldown.judgment.remains<gcd&cooldown.judgment.charges_fractional>1&cooldown_react)|!talent.crusaders_judgment.enabled"
				,"avengers_shield,,if=cooldown_react"
				,"judgment,if=cooldown_react|!talent.crusaders_judgment.enabled"
				,"blessed_hammer,strikes=2"
				,"hammer_of_the_righteous"
				,"consecration"
		)

	else
		-- Retribution
		-- https://github.com/simulationcraft/simc/commit/e1bfb5f06edd690ff100370e4212cf6a4f914a17

		x.HolyPower = s.Power("player",  Enum.PowerType.HolyPower )

		-- Executed before combat begins. Accepts non-harmful actions only.
		if not x.InCombat and x.Enemy then
			a.Flash(
				"flask"
				,"food"
				,"augmentation"
				,"potion"
				,"arcane_torrent,if=!talent.wake_of_ashes.enabled"
			)
		end

		a.Flash("rebuke")
--[[
--"call_action_list,name=opener"
-- Opener
-- ,"sequence,if=talent.wake_of_ashes.enabled&talent.crusade.enabled&talent.execution_sentence.enabled&!talent.hammer_of_wrath.enabled,name=wake_opener_ES_CS:shield_of_vengeance:blade_of_justice:judgment:crusade:templars_verdict:wake_of_ashes:templars_verdict:crusader_strike:execution_sentence"
		if talent.wake_of_ashes.enabled and talent.crusade.enabled and not talent.execution_sentence.enabled and not talent.hammer_of_wrath.enabled then
			-- wake_opener_CS
			a.Flash(
				"shield_of_vengeance"
				,"blade_of_justice"
				,"judgment"
				,"crusade"
				,"templars_verdict"
				,"wake_of_ashes"
				,"templars_verdict"
				,"crusader_strike"
				,"templars_verdict"
			)
,"sequence,if=talent.wake_of_ashes.enabled&talent.crusade.enabled&!talent.execution_sentence.enabled&!talent.hammer_of_wrath.enabled,name=wake_opener_CS:shield_of_vengeance:blade_of_justice:judgment:crusade:templars_verdict:wake_of_ashes:templars_verdict:crusader_strike:templars_verdict"
,"sequence,if=talent.wake_of_ashes.enabled&talent.crusade.enabled&talent.execution_sentence.enabled&talent.hammer_of_wrath.enabled,name=wake_opener_ES_HoW:shield_of_vengeance:blade_of_justice:judgment:crusade:templars_verdict:wake_of_ashes:templars_verdict:hammer_of_wrath:execution_sentence"
,"sequence,if=talent.wake_of_ashes.enabled&talent.crusade.enabled&!talent.execution_sentence.enabled&talent.hammer_of_wrath.enabled,name=wake_opener_HoW:shield_of_vengeance:blade_of_justice:judgment:crusade:templars_verdict:wake_of_ashes:templars_verdict:hammer_of_wrath:templars_verdict"
,"sequence,if=talent.wake_of_ashes.enabled&talent.inquisition.enabled,name=wake_opener_Inq:shield_of_vengeance:blade_of_justice:judgment:inquisition:avenging_wrath:wake_of_ashes"
	]]	
		-- Cooldowns
		s.UpdateBuff(31884, "Avenging Wrath")
		s.UpdateBuff(231895, "Crusade")
		s.UpdateBuff(84963, "Inquisition")
		a.Flash(
--			"use_item,name=jes_howler,if=buff.avenging_wrath.up|buff.crusade.up&buff.crusade.stack=10"
--			"potion,if=(buff.bloodlust.react|buff.avenging_wrath.up|buff.crusade.up&buff.crusade.remains<25|target.time_to_die<=40)"
--			,"fireblood,if=buff.avenging_wrath.up|buff.crusade.up&buff.crusade.stack=10"
			"shield_of_vengeance"
			,"avenging_wrath,if=buff.inquisition.up|!talent.inquisition.enabled"
			,"crusade,if=holy_power>=4"
		)

		-- Generators
		-- "variable,name=HoW,value=(!talent.hammer_of_wrath.enabled|target.health.pct>=20&(buff.avenging_wrath.down|buff.crusade.down))"
		x.Variable.HoW = not talent.hammer_of_wrath.enabled or target.health.pct >= 20 and (buff.avenging_wrath.down or buff.crusade.down)

		if x.HolyPower >= 5 then
			return a.FlashFinishers()
		end

		s.UpdateCooldown(184575, "Blade of Justice")
		s.UpdateCooldown(20271, "Judgment")
		s.UpdateCooldown(24275, "Hammer of Wrath")
		if a.Flash(
				"wake_of_ashes,if=(!raid_event.adds.exists|raid_event.adds.in>15|spell_targets.wake_of_ashes>=2)&(holy_power<=0|holy_power=1&cooldown.blade_of_justice.remains>gcd)"
				,"blade_of_justice,if=holy_power<=2|(holy_power=3&(cooldown.hammer_of_wrath.remains>gcd*2|variable.HoW))"
				,"judgment,if=holy_power<=2|(holy_power<=4&(cooldown.blade_of_justice.remains>gcd*2|variable.HoW))"
				,"hammer_of_wrath,if=holy_power<=4"
				,"consecration,if=holy_power<=2|holy_power<=3&cooldown.blade_of_justice.remains>gcd*2|holy_power=4&cooldown.blade_of_justice.remains>gcd*2&cooldown.judgment.remains>gcd*2"
			) then
			return
		end

		s.UpdateBuff(223819, "Divine Purpose")
		if talent.hammer_of_wrath.enabled and (target.health.pct <= 20 or buff.avenging_wrath.up or buff.crusade.up) and (buff.divine_purpose.up or buff.crusade.stack < 10) then
			return a.FlashFinishers()
		end

		s.UpdateCooldown(35395, "Crusader Strike")
		s.UpdateCooldown(26573, "Consecration")
		if a.Flash("crusader_strike,if=cooldown.crusader_strike.charges_fractional>=1.75&(holy_power<=2|holy_power<=3&cooldown.blade_of_justice.remains>gcd*2|holy_power=4&cooldown.blade_of_justice.remains>gcd*2&cooldown.judgment.remains>gcd*2&cooldown.consecration.remains>gcd*2)") then
			return
		end

		if a.FlashFinishers() then return end

		s.UpdateDebuff(267799, "Execution Sentence")
		a.Flash(
			"crusader_strike,if=holy_power<=4"
			,"arcane_torrent,if=(debuff.execution_sentence.up|(talent.hammer_of_wrath.enabled&(target.health.pct>=20|buff.avenging_wrath.down|buff.crusade.down))|!talent.execution_sentence.enabled|!talent.hammer_of_wrath.enabled)&holy_power<=4"
		)

	end
	
end)
